declare type LineIndex = number;
declare type ColumnIndex = number;
/**
 * Return the first and last indexes to focus, both included
 */
export declare function getFocusExtremes(focus: string | null, lines: any[]): [number, number];
export declare function getFocusIndexes(focus: string | null, lines: any[]): number[];
export declare function getFocusByKey(focus: string | null, keys: number[]): Record<number, boolean> | Record<number, true | number[]>;
export declare function parseFocus(focus: string): Record<number, true | number[]>;
export declare function getFocusSize(focus: Record<LineIndex, true | ColumnIndex[]>): {
    focusCenter: number;
    focusCount: number;
};
export declare class LineOrColumnNumberError extends Error {
    constructor();
}
export declare class FocusNumberError extends Error {
    number: string;
    constructor(number: string);
}
export {};
