'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
var miniFrame = require('@cross2d/mini-frame');
var classer = require('@code-hike/classer');
var miniTerminal = require('@cross2d/mini-terminal');
var codeDiff = require('@cross2d/code-diff');
var smoothLines = require('@cross2d/smooth-lines');
var useSpring = require('use-spring');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);

/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */
/* global Reflect, Promise */

var extendStatics = function(d, b) {
    extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
    return extendStatics(d, b);
};

function __extends(d, b) {
    extendStatics(d, b);
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __rest(s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
}

function __read(o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
}

function __spread() {
    for (var ar = [], i = 0; i < arguments.length; i++)
        ar = ar.concat(__read(arguments[i]));
    return ar;
}

var DEFAULT_HEIGHT = 200;
function EditorFrame(_a) {
    var files = _a.files, active = _a.active, children = _a.children, terminalPanel = _a.terminalPanel, height = _a.height, style = _a.style, button = _a.button, classes = _a.classes, rest = __rest(_a, ["files", "active", "children", "terminalPanel", "height", "style", "button", "classes"]);
    var c = classer.useClasser("ch-editor");
    return (React__default['default'].createElement(miniFrame.MiniFrame, __assign({ titleBar: React__default['default'].createElement(TabsContainer, { files: files, active: active, button: button }), classes: classes, style: __assign({ height: height !== null && height !== void 0 ? height : DEFAULT_HEIGHT }, style) }, rest),
        React__default['default'].createElement("div", { className: c("body") }, children),
        terminalPanel));
}
function TabsContainer(_a) {
    var files = _a.files, active = _a.active, button = _a.button;
    var c = classer.useClasser("ch-editor-tab");
    return (React__default['default'].createElement(React__default['default'].Fragment, null,
        React__default['default'].createElement(miniFrame.FrameButtons, null),
        files.map(function (fileName) { return (React__default['default'].createElement("div", { key: fileName, title: fileName, className: c("", fileName === active ? "active" : "inactive") },
            React__default['default'].createElement("div", null, fileName))); }),
        React__default['default'].createElement("div", { style: { flex: 1 } }),
        button));
}
function TerminalPanel(_a) {
    var height = _a.height, children = _a.children;
    return !height ? null : (React__default['default'].createElement("div", { className: "ch-editor-terminal", style: { height: height } },
        React__default['default'].createElement("div", { className: "ch-editor-terminal-tab" },
            React__default['default'].createElement("span", null, "Terminal")),
        React__default['default'].createElement("div", { className: "ch-editor-terminal-content" }, children)));
}

var useLayoutEffect = typeof window !== "undefined"
    ? React__default['default'].useLayoutEffect
    : React__default['default'].useEffect;
var DEFAULT_WIDTH = 200;
function useDimensions(deps) {
    var ref = React__default['default'].useRef(null);
    var _a = __read(React__default['default'].useState(null), 2), dimensions = _a[0], setDimensions = _a[1];
    var windowWidth = useWindowWidth();
    var fullDeps = __spread(deps, [windowWidth]);
    useLayoutEffect(function () {
        var _a, _b, _c, _d, _e, _f, _g, _h;
        if (ref.current) {
            var pll = ref.current.querySelector(".prev-longest-line");
            var nll = ref.current.querySelector(".next-longest-line");
            // TODO is it clientWidth or clientRect?
            var plw = (_a = pll === null || pll === void 0 ? void 0 : pll.firstElementChild) === null || _a === void 0 ? void 0 : _a.clientWidth;
            var nlw = (_b = nll === null || nll === void 0 ? void 0 : nll.firstElementChild) === null || _b === void 0 ? void 0 : _b.clientWidth;
            var plh = (_d = (_c = pll === null || pll === void 0 ? void 0 : pll.firstElementChild) === null || _c === void 0 ? void 0 : _c.clientHeight) !== null && _d !== void 0 ? _d : 20;
            var nlh = (_f = (_e = nll === null || nll === void 0 ? void 0 : nll.firstElementChild) === null || _e === void 0 ? void 0 : _e.clientHeight) !== null && _f !== void 0 ? _f : 20;
            var colWidth = pll
                ? plw / (((_g = pll.textContent) === null || _g === void 0 ? void 0 : _g.length) || 1)
                : nlw / (((_h = nll.textContent) === null || _h === void 0 ? void 0 : _h.length) || 1);
            setDimensions({
                width: getWidthWithoutPadding(ref.current),
                height: getHeightWithoutPadding(ref.current),
                lineWidths: [
                    plw || nlw || DEFAULT_WIDTH,
                    nlw || plw || DEFAULT_WIDTH,
                ],
                lineHeight: Math.max(plh, nlh),
                colWidth: colWidth,
                deps: fullDeps,
            });
        }
    }, fullDeps);
    if (!dimensions ||
        depsChanged(dimensions.deps, fullDeps)) {
        return [ref, null];
    }
    else {
        return [ref, dimensions];
    }
}
function getWidthWithoutPadding(element) {
    var computedStyle = getComputedStyle(element);
    return (element.clientWidth -
        parseFloat(computedStyle.paddingLeft) -
        parseFloat(computedStyle.paddingRight));
}
function getHeightWithoutPadding(element) {
    var computedStyle = getComputedStyle(element);
    return (element.clientHeight -
        parseFloat(computedStyle.paddingTop) -
        parseFloat(computedStyle.paddingBottom));
}
function depsChanged(oldDeps, newDeps) {
    for (var i = 0; i < oldDeps.length; i++) {
        if (oldDeps[i] !== newDeps[i])
            return true;
    }
    return false;
}
function useWindowWidth() {
    var _a = __read(React__default['default'].useState(undefined), 2), width = _a[0], setWidth = _a[1];
    React__default['default'].useEffect(function () {
        function handleResize() {
            setWidth(window.innerWidth);
        }
        window.addEventListener("resize", handleResize);
        return function () {
            return window.removeEventListener("resize", handleResize);
        };
    }, []);
    return width;
}

function getFocusIndexes(focus, lines) {
    if (!focus) {
        return __spread(lines.keys());
    }
    else {
        var parsed = parseFocus(focus);
        var focusedIndexes = Object.keys(parsed).map(function (i) {
            return parseInt(i, 10);
        });
        return focusedIndexes;
    }
}
function getFocusByKey(focus, keys) {
    if (!focus) {
        // focus all lines
        return fromEntries(keys.map(function (key) { return [key, true]; }));
    }
    else {
        var parsed_1 = parseFocus(focus);
        var byKey_1 = {};
        Object.keys(parsed_1).forEach(function (i) {
            var key = keys[parseInt(i, 10)];
            byKey_1[key] = parsed_1[parseInt(i, 10)];
        });
        return byKey_1;
    }
}
function parseFocus(focus) {
    if (!focus) {
        throw new Error("Focus cannot be empty");
    }
    try {
        var parts = focus
            .split(/,(?![^\[]*\])/g)
            .map(parsePart);
        return fromEntries(parts.flat());
    }
    catch (error) {
        // TODO enhance error
        throw error;
    }
}
function parsePart(part) {
    // a part could be
    // - a line number: "2"
    // - a line range: "5:9"
    // - a line number with a column selector: "2[1,3:5,9]"
    var columnsMatch = part.match(/(\d+)\[(.+)\]/);
    if (columnsMatch) {
        var _a = __read(columnsMatch, 3), line = _a[1], columns = _a[2];
        var columnsList = columns.split(",").map(expandString);
        var lineIndex = Number(line) - 1;
        var columnIndexes = columnsList.flat().map(function (c) { return c - 1; });
        return [[lineIndex, columnIndexes]];
    }
    else {
        return expandString(part).map(function (lineNumber) { return [
            lineNumber - 1,
            true,
        ]; });
    }
}
function expandString(part) {
    // Transforms something like
    // - "1:3" to [1,2,3]
    // - "4" to [4]
    var _a = __read(part.split(":"), 2), start = _a[0], end = _a[1];
    if (!isNaturalNumber(start)) {
        throw new FocusNumberError(start);
    }
    var startNumber = Number(start);
    if (startNumber < 1) {
        throw new LineOrColumnNumberError();
    }
    if (!end) {
        return [startNumber];
    }
    else {
        if (!isNaturalNumber(end)) {
            throw new FocusNumberError(end);
        }
        var list = [];
        for (var i = startNumber; i <= +end; i++) {
            list.push(i);
        }
        return list;
    }
}
function isNaturalNumber(n) {
    n = n.toString(); // force the value in case it is not
    var n1 = Math.abs(n), n2 = parseInt(n, 10);
    return !isNaN(n1) && n2 === n1 && n1.toString() === n;
}
var LineOrColumnNumberError = /** @class */ (function (_super) {
    __extends(LineOrColumnNumberError, _super);
    function LineOrColumnNumberError() {
        var _newTarget = this.constructor;
        var _this = _super.call(this, "Invalid line or column number in focus string") || this;
        Object.setPrototypeOf(_this, _newTarget.prototype);
        return _this;
    }
    return LineOrColumnNumberError;
}(Error));
var FocusNumberError = /** @class */ (function (_super) {
    __extends(FocusNumberError, _super);
    function FocusNumberError(number) {
        var _newTarget = this.constructor;
        var _this = _super.call(this, "Invalid number \"" + number + "\" in focus string") || this;
        _this.number = number;
        Object.setPrototypeOf(_this, _newTarget.prototype);
        return _this;
    }
    return FocusNumberError;
}(Error));
function fromEntries(pairs) {
    var result = {};
    var index = -1, length = pairs == null ? 0 : pairs.length;
    while (++index < length) {
        var pair = pairs[index];
        result[pair[0]] = pair[1];
    }
    return result;
}

function Code(_a) {
    var prevCode = _a.prevCode, prevFocus = _a.prevFocus, nextCode = _a.nextCode, nextFocus = _a.nextFocus, progress = _a.progress, language = _a.language, parentHeight = _a.parentHeight, minColumns = _a.minColumns; _a.minZoom; var maxZoom = _a.maxZoom, horizontalCenter = _a.horizontalCenter;
    var _b = useLineProps(prevCode, nextCode, language, prevFocus, nextFocus), prevLines = _b.prevLines, nextLines = _b.nextLines, prevFocusIndexes = _b.prevFocusIndexes, nextFocusIndexes = _b.nextFocusIndexes, prevLongestLine = _b.prevLongestLine, nextLongestLine = _b.nextLongestLine;
    var _c = __read(useDimensions([
        parentHeight,
        prevLongestLine,
        nextLongestLine,
    ]), 2), ref = _c[0], dimensions = _c[1];
    return (React__default['default'].createElement("pre", { ref: ref, className: "language-" + language, style: {
            opacity: dimensions ? 1 : 0,
            overflow: dimensions ? undefined : "hidden",
        } },
        React__default['default'].createElement("code", null, dimensions ? (React__default['default'].createElement(smoothLines.SmoothLines, { progress: progress, containerWidth: dimensions.width, containerHeight: dimensions.height, prevLines: prevLines, nextLines: nextLines, lineHeight: dimensions.lineHeight, lineWidth: dimensions.lineWidths.map(function (lw) {
                return Math.max(lw, dimensions.colWidth * minColumns);
            }), prevFocus: prevFocusIndexes, nextFocus: nextFocusIndexes, maxZoom: maxZoom, center: horizontalCenter })) : (React__default['default'].createElement(React__default['default'].Fragment, null,
            React__default['default'].createElement("div", { className: "prev-longest-line" }, prevLongestLine),
            React__default['default'].createElement("div", { className: "next-longest-line" }, nextLongestLine))))));
}
function useLineProps(prevCode, nextCode, language, prevFocus, nextFocus) {
    return React__default['default'].useMemo(function () {
        var _a, _b;
        var _c = codeDiff.codeDiff({
            prevCode: prevCode,
            nextCode: nextCode,
            lang: language,
        }), prevKeys = _c.prevKeys, nextKeys = _c.nextKeys, codeMap = _c.codeMap;
        var prevFocusByKey = getFocusByKey(prevFocus, prevKeys);
        var prevFocusIndexes = getFocusIndexes(prevFocus, prevKeys);
        var prevLongestLineIndex = longestLineIndex(prevCode, prevFocusIndexes);
        var nextFocusByKey = getFocusByKey(nextFocus, nextKeys);
        var nextFocusIndexes = getFocusIndexes(nextFocus, nextKeys);
        var nextLongestLineIndex = longestLineIndex(nextCode, nextFocusIndexes);
        var prevLines = prevKeys.map(function (key) {
            var prevFocus = prevFocusByKey[key];
            var nextFocus = nextFocusByKey[key];
            var focusPerColumn = Array.isArray(prevFocus) || Array.isArray(nextFocus);
            if (!focusPerColumn) {
                return {
                    key: key,
                    element: React__default['default'].createElement(Line, { line: codeMap[key] }),
                };
            }
            else {
                return {
                    key: key,
                    element: React__default['default'].createElement(Line, { line: codeMap[key] }),
                    elementWithProgress: function (progress) { return (React__default['default'].createElement(ColumnedLine, { line: codeMap[key], progress: progress, prevFocus: prevFocus, nextFocus: nextFocus })); },
                };
            }
        });
        var prevLongestLine = prevLongestLineIndex == null
            ? null
            : (_a = prevLines[prevLongestLineIndex]) === null || _a === void 0 ? void 0 : _a.element;
        var nextLines = nextKeys.map(function (key) {
            var prevFocus = prevFocusByKey[key];
            var nextFocus = nextFocusByKey[key];
            var focusPerColumn = Array.isArray(prevFocus) || Array.isArray(nextFocus);
            if (!focusPerColumn) {
                return {
                    key: key,
                    element: React__default['default'].createElement(Line, { line: codeMap[key] }),
                };
            }
            else {
                return {
                    key: key,
                    element: React__default['default'].createElement(Line, { line: codeMap[key] }),
                    elementWithProgress: function (progress) { return (React__default['default'].createElement(ColumnedLine, { line: codeMap[key], progress: progress, prevFocus: prevFocus, nextFocus: nextFocus })); },
                };
            }
        });
        var nextLongestLine = nextLongestLineIndex == null
            ? null
            : (_b = nextLines[nextLongestLineIndex]) === null || _b === void 0 ? void 0 : _b.element;
        return {
            prevLines: prevLines,
            nextLines: nextLines,
            prevFocusIndexes: prevFocusIndexes,
            nextFocusIndexes: nextFocusIndexes,
            prevLongestLine: prevLongestLine,
            nextLongestLine: nextLongestLine,
        };
    }, [prevCode, nextCode, language, prevFocus, nextFocus]);
}
function Line(_a) {
    var line = _a.line;
    return (React__default['default'].createElement("div", { style: {
            display: "inline-block",
        } },
        line.map(function (_a, i) {
            var _b = __read(_a, 2), token = _b[0], type = _b[1];
            return (React__default['default'].createElement("span", { className: "token " + type, key: i + 1 }, token));
        }),
        React__default['default'].createElement("br", null)));
}
var OFF_OPACITY = 0.33;
function ColumnedLine(_a) {
    var line = _a.line, progress = _a.progress, prevFocus = _a.prevFocus, nextFocus = _a.nextFocus;
    var columns = React__default['default'].useMemo(function () {
        var chars = flatMap(line, function (_a) {
            var _b = __read(_a, 2), token = _b[0], type = _b[1];
            return token.split("").map(function (char) { return [char, type]; });
        });
        return chars.map(function (_a, i) {
            var _b = __read(_a, 2), char = _b[0], type = _b[1];
            return ({
                char: char,
                type: type,
                fromOpacity: !prevFocus
                    ? 0.99 // because the line is already transparent
                    : prevFocus === true || prevFocus.includes(i)
                        ? 0.99
                        : OFF_OPACITY,
                toOpacity: !nextFocus
                    ? 0.99 // because the line is already transparent
                    : nextFocus === true || nextFocus.includes(i)
                        ? 0.99
                        : OFF_OPACITY,
            });
        });
    }, [line, prevFocus, nextFocus]);
    return (React__default['default'].createElement("div", { style: {
            display: "inline-block",
            width: "100%",
        } },
        columns.map(function (_a, i) {
            var char = _a.char, type = _a.type, fromOpacity = _a.fromOpacity, toOpacity = _a.toOpacity;
            return (React__default['default'].createElement("span", { className: "token " + type, key: i + 1, style: {
                    opacity: tween(fromOpacity, toOpacity, progress),
                } }, char));
        }),
        React__default['default'].createElement("br", null)));
}
function tween(p, n, t) {
    return (n - p) * t + p;
}
var newlineRe = /\r\n|\r|\n/;
function longestLineIndex(code, focusIndexes) {
    var first = Math.min.apply(Math, __spread(focusIndexes));
    var last = Math.max.apply(Math, __spread(focusIndexes));
    var focusedLines = code == null
        ? []
        : code.split(newlineRe).slice(first, last + 1);
    if (!focusedLines.length) {
        return null;
    }
    var longestIndex = 0;
    for (var i = 1; i < focusedLines.length; i++) {
        if (focusedLines[i].length >
            focusedLines[longestIndex].length) {
            longestIndex = i;
        }
    }
    return first + longestIndex;
}
function flatMap(array, callbackfn) {
    var _a;
    return (_a = Array.prototype).concat.apply(_a, __spread(array.map(callbackfn)));
}

function useForwardTransitions(steps) {
    console.log("useForwardTransitions steps===>", steps);
    return React__default['default'].useMemo(function () {
        var transitions = steps.map(function (step, i) {
            var prevStepForFile = null;
            for (var j = i - 1; j >= 0; j--) {
                if (steps[j].file === step.file) {
                    prevStepForFile = steps[j];
                    break;
                }
            }
            return {
                prevCode: prevStepForFile && prevStepForFile.code,
                prevFocus: prevStepForFile && prevStepForFile.focus,
                nextCode: step.code,
                nextFocus: step.focus,
                file: step.file,
                lang: step.lang,
            };
        });
        var lastStep = steps[steps.length - 1];
        transitions.push({
            file: lastStep.file,
            prevCode: lastStep.code,
            prevFocus: lastStep.focus,
            nextCode: null,
            nextFocus: null,
            lang: lastStep.lang,
        });
        return transitions;
    }, [steps]);
}
function useBackwardTransitions(steps) {
    return React__default['default'].useMemo(function () {
        var transitions = [];
        transitions.push({
            prevCode: null,
            prevFocus: null,
            nextCode: steps[0].code,
            nextFocus: steps[0].focus,
            lang: steps[0].lang,
            file: steps[0].file,
        });
        steps.forEach(function (step, i) {
            var nextStepForFile = null;
            for (var j = i + 1; j < steps.length; j++) {
                if (steps[j].file === step.file) {
                    nextStepForFile = steps[j];
                    break;
                }
            }
            transitions.push({
                prevCode: step.code,
                prevFocus: step.focus,
                nextCode: nextStepForFile && nextStepForFile.code,
                nextFocus: nextStepForFile && nextStepForFile.focus,
                lang: step.lang,
                file: step.file,
            });
        });
        return transitions;
    }, [steps]);
}

function MiniEditorHike(props) {
    console.log("MiniEditorHike-->", props);
    var _a = props.progress, progress = _a === void 0 ? 0 : _a, _b = props.backward, backward = _b === void 0 ? false : _b, code = props.code, focus = props.focus, lang = props.lang, file = props.file, ogSteps = props.steps, ogTabs = props.tabs, _c = props.minColumns, minColumns = _c === void 0 ? 50 : _c, _d = props.minZoom, minZoom = _d === void 0 ? 0.2 : _d, _e = props.maxZoom, maxZoom = _e === void 0 ? 1 : _e, height = props.height, _f = props.horizontalCenter, horizontalCenter = _f === void 0 ? false : _f, rest = __rest(props, ["progress", "backward", "code", "focus", "lang", "file", "steps", "tabs", "minColumns", "minZoom", "maxZoom", "height", "horizontalCenter"]);
    var _g = useSteps(ogSteps, {
        code: code,
        focus: focus,
        lang: lang,
        file: file,
        tabs: ogTabs,
    }), steps = _g.steps, files = _g.files, stepsByFile = _g.stepsByFile;
    var activeStepIndex = backward
        ? Math.floor(progress)
        : Math.ceil(progress);
    var activeStep = steps[activeStepIndex];
    var activeFile = (activeStep && activeStep.file) || "";
    var activeSteps = stepsByFile[activeFile] || [];
    var tabs = activeStep.tabs || files;
    var terminalHeight = getTerminalHeight(steps, progress);
    var terminalSteps = steps.map(function (s) { return ({
        text: (s && s.terminal) || "",
    }); });
    var contentSteps = useStepsWithDefaults({ code: code, focus: focus, lang: lang, file: file }, ogSteps || []);
    return (React__default['default'].createElement(EditorFrame, __assign({ files: tabs, active: activeFile, terminalPanel: React__default['default'].createElement(TerminalPanel, { height: terminalHeight },
            React__default['default'].createElement(miniTerminal.InnerTerminal, { steps: terminalSteps, progress: progress })), height: height }, rest), activeSteps.length > 0 && (React__default['default'].createElement(EditorContent, { key: activeFile, backward: backward, progress: progress, steps: contentSteps, parentHeight: height, minColumns: minColumns, minZoom: minZoom, maxZoom: maxZoom, horizontalCenter: horizontalCenter }))));
}
function useStepsWithDefaults(defaults, steps) {
    var files = __spread(new Set(steps.map(function (s) { return coalesce(s.file, defaults.file, ""); })));
    return steps.map(function (step) {
        return {
            code: coalesce(step.code, defaults.code, ""),
            file: coalesce(step.file, defaults.file, ""),
            focus: coalesce(step.focus, defaults.focus, ""),
            lang: coalesce(step.lang, defaults.lang, "javascript"),
            tabs: coalesce(step.tabs, defaults.tabs, files),
            terminal: step.terminal || defaults.terminal,
        };
    });
}
function coalesce(a, b, c) {
    return a != null ? a : b != null ? b : c;
}
function EditorContent(_a) {
    var progress = _a.progress, backward = _a.backward, steps = _a.steps, parentHeight = _a.parentHeight, minColumns = _a.minColumns, minZoom = _a.minZoom, maxZoom = _a.maxZoom, horizontalCenter = _a.horizontalCenter;
    debugger;
    var fwdTransitions = useForwardTransitions(steps);
    var bwdTransitions = useBackwardTransitions(steps);
    var transitionIndex = Math.ceil(progress);
    var _b = backward
        ? bwdTransitions[transitionIndex]
        : fwdTransitions[transitionIndex], prevCode = _b.prevCode, nextCode = _b.nextCode, prevFocus = _b.prevFocus, nextFocus = _b.nextFocus, lang = _b.lang;
    return (React__default['default'].createElement(Code, { prevCode: prevCode || nextCode, nextCode: nextCode || prevCode, prevFocus: prevFocus, nextFocus: nextFocus, language: lang, progress: progress - transitionIndex + 1, parentHeight: parentHeight, minColumns: minColumns, minZoom: minZoom, maxZoom: maxZoom, horizontalCenter: horizontalCenter }));
}
function useSteps(ogSteps, _a) {
    var _b = _a.code, code = _b === void 0 ? "" : _b, focus = _a.focus, lang = _a.lang, file = _a.file, tabs = _a.tabs;
    return React__default['default'].useMemo(function () {
        var steps = (ogSteps === null || ogSteps === void 0 ? void 0 : ogSteps.map(function (s) { return (__assign({ code: code,
            focus: focus,
            lang: lang,
            file: file,
            tabs: tabs }, s)); })) || [{ code: code, focus: focus, lang: lang, file: file, tabs: tabs }];
        var files = __spread(new Set(steps
            .map(function (s) { return s.file; })
            .filter(function (f) { return f != null; })));
        var stepsByFile = {};
        steps.forEach(function (s) {
            if (s.file == null)
                return;
            if (!stepsByFile[s.file]) {
                stepsByFile[s.file] = [];
            }
            stepsByFile[s.file].push(s);
        });
        return { steps: steps, files: files, stepsByFile: stepsByFile };
    }, [ogSteps, code, focus, lang, file, tabs]);
}
var MAX_HEIGHT = 150;
function getTerminalHeight(steps, progress) {
    if (!steps.length) {
        return 0;
    }
    var prevIndex = Math.floor(progress);
    var nextIndex = Math.ceil(progress);
    var prevTerminal = steps[prevIndex] && steps[prevIndex].terminal;
    var nextTerminal = steps[nextIndex].terminal;
    if (!prevTerminal && !nextTerminal)
        return 0;
    if (!prevTerminal && nextTerminal)
        return MAX_HEIGHT * Math.min((progress % 1) * 4, 1);
    if (prevTerminal && !nextTerminal)
        return MAX_HEIGHT * Math.max(1 - (progress % 1) * 4, 0);
    return MAX_HEIGHT;
}

function MiniEditor(_a) {
    var focus = _a.focus, code = _a.code, rest = __rest(_a, ["focus", "code"]);
    var _b = __read(usePrevFocus(code, focus), 2), steps = _b[0], progress = _b[1];
    return (React__default['default'].createElement(MiniEditorHike, __assign({ progress: progress, steps: steps }, rest)));
}
function usePrevFocus(code, focus) {
    var _a = __read(React__default['default'].useState({
        target: 0,
        steps: [{ focus: focus, code: code }],
    }), 2), state = _a[0], setState = _a[1];
    React__default['default'].useEffect(function () {
        var last = state.steps[state.steps.length - 1];
        if (last.focus !== focus || last.code !== code) {
            setState(function (s) { return ({
                target: s.target + 1,
                steps: __spread(s.steps, [{ focus: focus, code: code }]),
            }); });
        }
    }, [focus, code]);
    var _b = __read(useSpring.useSpring(state.target, {
        stiffness: 256,
        damping: 24,
        mass: 0.2,
        decimals: 3,
    }), 1), progress = _b[0];
    return [state.steps, progress];
}

exports.MiniEditor = MiniEditor;
exports.MiniEditorHike = MiniEditorHike;
//# sourceMappingURL=index.cjs.js.map
